- 41.9%

https://leetcode.com/problems/burst-balloons/

Given **n** balloons, indexed from **0** to **n-1**. Each balloon is painted with a number on it represented by array **nums**. You are asked to burst all the balloons. If the you burst balloon **i** you will get **nums[left] nums[i] nums[right]** coins. Here left and right are adjacent indices of i. After the burst, the left and right then becomes adjacent.

Find the maximum coins you can collect by bursting the balloons wisely.

Note:

(1) You may imagine nums[-1] = nums[n] = 1. They are not real therefore you can not burst them.

(2) 0 ≤ n ≤ 500, 0 ≤ nums[i] ≤ 100

1 | Example: |

先戳破第一个气球，直到最后一个，即第n个。

重点是逆向思考，先第n个，再第n-1个，直到第一个。

一个vector<vector

dp[left][right]表示索引left至索引right里面，不戳破left和right，戳破[left+1, right-1]中任意顺序能获得的最大值。

假定最后戳破某一位i，则得到奖励nums[left]*nums[i]*nums[right]，并且获得dp[left][i]和dp[i][right]。而dp[i][left]又是类似于前一个问题，而且跟i关系不大。

下面两个方法分别是递归和迭代

方法一：

我的代码实现：

1 | class Solution { |

方法二：

我的代码实现：

1 | class Solution { |

方法一和方法二参考以下文章

https://discuss.leetcode.com/topic/41086/c-dp-detailed-explanation

C++ dp detailed explanation

the visualization help me to understand hope it can help you too.

1···················1

add two 1 at beginning and end of nums, each · represent each number in nums.

len is the subinterval length, it grows from 1 to full length of orignal nums string.

the following illustrations demonstrate how the subinterval shift from left to right. (len = 7 in the illustration)

for each len, when shifted to rightmost, increase len and do the shift again. this way we can evaluate all possible subintervals.

for each subinterval, in the innermost for loop, find which balloon to burst LAST that will give us the most coins for that subinterval. <- IMPORTANT TO UNDERSTAND THIS

dp[left][right] is the maximum coins we can get from left to right. note when left > right, it is 0

1 | 1···················1 (len = 7) |

for the example [3, 1, 5, 8], the dp matrix is updated like this

1 | 0 0 0 0 0 0 |

then

1 | 0 0 0 0 0 0 |

at last

1 | 0 0 0 0 0 0 |

the code is like most others.

1 | class Solution { |

https://discuss.leetcode.com/topic/30746/share-some-analysis-and-explanations

Share some analysis and explanations

#### Be Naive First

When I first get this problem, it is far from dynamic programming to me. I started with the most naive idea the backtracking.

We have n balloons to burst, which mean we have n steps in the game. In the i th step we have n-i balloons to burst, i = 0~ n-1. Therefore we are looking at an algorithm of O(n!). Well, it is slow, probably works for n < 12 only.

Of course this is not the point to implement it. We need to identify the redundant works we did in it and try to optimize.

Well, we can find that for any balloons left the maxCoins does not depends on the balloons already bursted. This indicate that we can use memorization (top down) or dynamic programming (bottom up) for all the cases from small numbers of balloon until n balloons. How many cases are there? For k balloons there are C(n, k) cases and for each case it need to scan the k balloons to compare. The sum is quite big still. It is better than O(n!) but worse than O(2^n).

#### Better idea

We then think can we apply the divide and conquer technique? After all there seems to be many self similar sub problems from the previous analysis.

Well, the nature way to divide the problem is burst one balloon and separate the balloons into 2 sub sections one on the left and one one the right. However, in this problem the left and right become adjacent and have effects on the maxCoins in the future.

Then another interesting idea come up. Which is quite often seen in dp problem analysis. That is reverse thinking. Like I said the coins you get for a balloon does not depend on the balloons already burst. Therefore

instead of divide the problem by the first balloon to burst, we divide the problem by the last balloon to burst.

Why is that? Because only the first and last balloons we are sure of their adjacent balloons before hand!

For the first we have nums[i-1]*nums[i]*nums[i+1] for the last we have nums[-1]*nums[i]*nums[n].

OK. Think about n balloons if i is the last one to burst, what now?

We can see that the balloons is again separated into 2 sections. But this time since the balloon i is the last balloon of all to burst, the left and right section now has well defined boundary and do not affect each other! Therefore we can do either recursive method with memoization or dp.

#### Final

Here comes the final solutions. Note that we put 2 balloons with 1 as boundaries and also burst all the zero balloons in the first round since they won’t give any coins.

The algorithm runs in O(n^3) which can be easily seen from the 3 loops in dp solution.

Java D&C with Memoization

1 | public int maxCoins(int[] iNums) { |

Java DP

1 | public int maxCoins(int[] iNums) { |

C++ DP

1 | int maxCoinsDP(vector<int> &iNums) { |

Python DP

1 | def maxCoins(self, iNums): |

https://discuss.leetcode.com/topic/30738/c-dynamic-programming-o-n-3-32-ms-with-comments

C++ dynamic programming, O(N^3), 32 ms, with comments

1 | int maxCoins(vector<int>& nums) { |

https://discuss.leetcode.com/topic/30934/my-c-code-dp-o-n-3-20ms

My C++ code (DP, O(N^3)) 20ms

The algorithm is well explained in 1 and I pretty much followed the same line.

- First version I got is recursion +backtracing (TLE)
- Second version I got is DP:

instead of bursting ballons one by one, we do it in a reverse order, “de-burst” ballons one by one. In that order, the left and right neighbor of the “de-burst” ballon is known. However, the complexity is still high (~ order of C(n,n/2))

The real challenge is the outer boundaries (i.e. left, right neighbors vary with the burst order). The algorithm in 1 elegantly fixed that problem: fix left/right neighbors and doing DP from length=3 to nSize;

1 | class Solution { |

https://discuss.leetcode.com/topic/31178/python-dp-n-3-solutions

Python DP N^3 Solutions

Analysis:

We need to find a way to divide the problems. If we start from the first balloon, we can’t determine the left/right for the number in each sub-problem, If we start from the last balloon, we can.

We can see the transformation equation is very similar to the one for matrix multiplication.

dp[i][j] = max(dp[i][j], nums[i] * nums[k] * nums[j] + dp[i][k] + dp[k][j]) # i < k < j

This is a typical interval DP problem. Because the order of the number extracted matters, we need to do a O(n^3) DP. If we only need to expand the interval to the left or right, we only need to do a O(n^2) DP.

Top-down:

1 | class Solution(object): |

Bottom-up:

1 | class Solution(object): |

#### java

https://discuss.leetcode.com/topic/30746/share-some-analysis-and-explanations

Be Naive FirstWhen I first get this problem, it is far from dynamic programming to me. I started with the most naive idea the backtracking.

We have n balloons to burst, which mean we have n steps in the game. In the i th step we have n-i balloons to burst, i = 0~ n-1. Therefore we are looking at an algorithm of O(n!). Well, it is slow, probably works for n < 12 only.

Of course this is not the point to implement it. We need to identify the redundant works we did in it and try to optimize.

Well, we can find that for any balloons left the maxCoins does not depends on the balloons already bursted. This indicate that we can use memorization (top down) or dynamic programming (bottom up) for all the cases from small numbers of balloon until n balloons. How many cases are there? For k balloons there are C(n, k) cases and for each case it need to scan the k balloons to compare. The sum is quite big still. It is better than O(n!) but worse than O(2^n).

Better idea

We then think can we apply the divide and conquer technique? After all there seems to be many self similar sub problems from the previous analysis.

Well, the nature way to divide the problem is burst one balloon and separate the balloons into 2 sub sections one on the left and one one the right. However, in this problem the left and right become adjacent and have effects on the maxCoins in the future.

Then another interesting idea come up. Which is quite often seen in dp problem analysis. That is reverse thinking. Like I said the coins you get for a balloon does not depend on the balloons already burst. Therefore

instead of divide the problem by the first balloon to burst, we divide the problem by the last balloon to burst.Why is that? Because only the first and last balloons we are sure of their adjacent balloons before hand!

For the first we have nums[i-1]*nums[i]* nums[i+1] for the last we have nums[-1]*nums[i]*nums[n] .

OK. Think about n balloons if i is the last one to burst, what now?

We can see that the balloons is again separated into 2 sections. But this time since the balloon i is the last balloon of all to burst, the left and right section now has well defined boundary and do not affect each other! Therefore we can do either recursive method with memoization or dp.

Final

Here comes the final solutions. Note that we put 2 balloons with 1 as boundaries and also burst all the zero balloons in the first round since they won’t give any coins.

The algorithm runs in O ( n\^3 ) which can be easily seen from the 3 loops in dp solution.

Java D&C with Memoization

1 | public class Solution { |

**Java DP**

19ms, September 9, 2016

https://discuss.leetcode.com/topic/30746/share-some-analysis-and-explanations

1 | public class Solution { |

#### cpp

19ms, September 9, 2016

https://discuss.leetcode.com/topic/30746/share-some-analysis-and-explanations

1 | class Solution { |

#### python

416ms, September 9, 2016

https://discuss.leetcode.com/topic/31178/python-dp-n-3-solutions

1 | class Solution(object): |

972ms, September 9, 2016

https://discuss.leetcode.com/topic/31178/python-dp-n-3-solutions

1 | class Solution(object): |